#ifndef Y86_L_H
#define Y86_L_H

#include "systemc.h"

// Opcodes
#define add    0x01
#define sub    0x29
#define hlt    0xf4
#define jnz    0x75
#define MRmov  0x8b
#define RMmov  0x89

// Extract the split Felder eines Befehls
// Example from Bitmasks.

#define EXTEND8(x) ((signed int)(signed char)(x))
#define RD(I)      (I&0x07)
#define RS(I)      ((I&0x38)>>3)
#define mod(I)     ((I&0xc0)>>6)

SC_MODULE(cpu_Y86_H)
{
  // inputs, outputs
  unsigned IP_;			//Instruction pointer
  unsigned char MEM_[100];	// Main memory: 100 address
  unsigned R_[8];		// correctness of the registers
  bool ZF_;			// Flags

  // internal variables
  
  void init();
  void show();		//states show
  void step();		// An instruction execution
  void run();		// progrem exeuction
  
  SC_CTOR(cpu_Y86_H)
  {
    SC_THREAD(run);
  }
};

#endif
