`timescale 1ns / 1ps

module showhex(input clk,
               input hilo, input [31:0] value,
               output [7:0] lines, output [3:0] anodes);
   
   localparam [2:0]
     Q1 = 'b000,
     Q2 = 'b001,
     Q3 = 'b010,
     Q4 = 'b011,
     Q5 = 'b100,
     Q6 = 'b101,
     Q7 = 'b110,
     Q8 = 'b111;
   
   reg [7:0] valuesA, valuesB, valuesC, valuesD;
   reg [2:0] state=Q1, next_state;
   reg [9:0] counter;
	
	localparam [7:0]
	  t_0 = 'b00000011,
     t_1 = 'b10011111,
     t_2 = 'b00100101,
     t_3 = 'b00001101,
     t_4 = 'b10011001,
     t_5 = 'b01001001,
     t_6 = 'b01000001,
     t_7 = 'b00011111,
     t_8 = 'b00000001,
     t_9 = 'b00001001,
     t_A = 'b00010001,
     t_b = 'b11000001,
     t_C = 'b01100011,
     t_d = 'b10000101,
     t_E = 'b01100001,
     t_F = 'b01110001;
	  
	function [7:0] hexval;
	  input [3:0] a;
    hexval=(a==0) ? t_0 : (a==1) ? t_1 : (a==2) ? t_2 : (a==3) ? t_3 : 
	 (a==4) ? t_4 : (a==5) ? t_5 : (a==6) ? t_6 : (a==7) ? t_7 : 
	 (a==8) ? t_8 : (a==9) ? t_9 : (a==10) ? t_A : (a==11) ? t_b : 
	 (a==12) ? t_C : (a==13) ? t_d : (a==14) ? t_E : t_F;
	 endfunction

   always @(posedge clk) begin // Values
     valuesA = (hilo) ? hexval(value[31:28]) : hexval(value[15:12]);
	  valuesB = (hilo) ? hexval(value[27:24]) : hexval(value[11:8]);
	  valuesC = (hilo) ? hexval(value[23:20]) : hexval(value[7:4]);
	  valuesD = (hilo) ? hexval(value[19:16]) : hexval(value[3:0]);
   end
   
   always @(posedge clk)
     state = next_state;

   always @(posedge clk) begin
      if (counter==1000) begin
	 next_state=state+1;
	 counter=0;
      end
      else
	counter=counter+1;
   end
   
   assign lines = (state==Q1 || state==Q2)? valuesA :
		  (state==Q3 || state==Q4)? valuesB :
		  (state==Q5 || state==Q6)? valuesC :
		  (state==Q7 || state==Q8)? valuesD : 'b11111111;
   
   assign anodes =(state==Q1)? 'b0111 :
		  (state==Q3)? 'b1011 :
		  (state==Q5)? 'b1101 :
		  (state==Q7)? 'b1110 : 'b1111;

endmodule
