//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//-- This confidential and proprietary software may be used only as authorized 
//-- by a licensing agreement from ESD University of Verona - EDALab s.r.l.                      
//--                                                                            
//--                                                                           
//-- Title:             Multimedia System Design Developement
//-- Project:           V-CLIP 1.0
//--    
//-- 
//-- File:              adpcm_UT.h
//-- 
//-- Mod History: $Log: $
//                                                                            
//----------------------------------------------------------------------------
//-- RCS Version:  $Id: $                                           
//----------------------------------------------------------------------------

#include <systemc.h>

// DATA TYPE DEFINITIONS
typedef struct
{
	short len;
	short sample;
	char  result;
} DATA_TYPE_adpcm;

struct packet_adpcm {
	short* sbuf;
	int len;
};

// Added for the simulation of abstracted ADPCM module.
struct iostruct {
	sc_uint<16> len;
	sc_int<16> indata;
	char outdata;
	bool outdata_enable;
	bool indata_enable;
	bool len_enable;
};


typedef unsigned int ADDRESS_TYPE;

// CONSTANTS
#define ADPCM_ADDR   5
#define NSAMPLES   200
#define CLKTIME      1
#define TIMETYPE SC_NS

SC_MODULE(adpcm_UT) 
{

  // Local variables in the original SystemC RTL design.
  // Cannot be declared and initialized as class variables,
  // so we move them inside the original method.

  int flag_return;

  iostruct ioDataStruct;

  typedef enum 
	{
    RESET, PRE1, PRE2, STEP01, STEP0, 
    STEP1, STEP2, STEP3, STEP4, STEP5, STEP6
  }  state_adpcm;

  state_adpcm state;
  state_adpcm next_state;

  char c;
  char outputbuffer;

  sc_int<16> val;
  sc_uint<4> sign;
  sc_uint<4> delta;
  sc_uint<18> step;
  sc_uint<18> vpdiff;
  sc_uint<16> len_value;
  int valpred;
  int diff;
  int index;
  bool bufferstep;

  void adpcm_coder();
  void reset();
	void run();
	
	SC_CTOR(adpcm_UT)
	{
		SC_THREAD(run);
	}
};
