//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//-- This confidential and proprietary software may be used only as authorized 
//-- by a licensing agreement from ESD University of Verona - EDALab s.r.l.                      
//--
//--
//-- Title:             Multimedia System Design Developement
//-- Project:           V-CLIP 1.0
//--
//-- 
//-- File:              b01_RTL.h
//-- Author:            Nicola Bombieri
//-- Date:              24 December 2005 
//-- Description:       RTL b01 module
//-- 
//-- Mod History: $Log: $
//                                                                            
//----------------------------------------------------------------------------
//-- RCS Version:  $Id: $                                           
//----------------------------------------------------------------------------

// Modified by Nannan He

#include <systemc.h>

SC_MODULE(b01_RTL) 
{
public:
  sc_in   <bool > clock;
  sc_in   <bool > reset;
  sc_in   <bool > line1;
  sc_in   <bool > line2; 
	
  sc_out  <bool > outp;
  sc_out  <bool > overflw;
  
  void process();
  sc_uint<3> stato;
  
  SC_CTOR(b01_RTL)
  {
    SC_METHOD(process);
    sensitive_pos << clock << reset;
  }
  
  ~b01_RTL()
  {  }
};

