`include "bcd_to_binary.v"

module top ();

reg clk_i;
reg [4:0] dat_bcd_i;

wire [3:0] dat_bin_o;
wire [3:0] dat_gray_o;

reg [4:0] dat_bcd_i_tmp;

// Clock generator
always begin
  #5 
  clk_i = ~clk_i;
end

initial begin
  $dumpfile("bcd_to_binary.vcd");
  $dumpvars();

	clk_i <= 0;

	repeat(10) begin
		@ (posedge clk_i);
		dat_bcd_i_tmp = $random % 32;
		if(dat_bcd_i == dat_bcd_i_tmp)
		begin
			dat_bcd_i = $random % 32;
		end
		else			
			dat_bcd_i = dat_bcd_i_tmp;

		$display("%d\ti_x%d:", 
			$time, 
			dat_bcd_i
		);
		#2
		$display("%d\to_x%d:%d:", 
			$time, 
			dat_bin_o,
			dat_gray_o
		);
	end
	$finish;
end 

// Connect the DUT
bcd_to_binary U(
  clk_i, 
	dat_bcd_i, 
	dat_bin_o,
	dat_gray_o
);

endmodule
