#include <iostream>
#include <systemc>
#include "directcontrol_H.h"

//----------------------------------
#define MAX_ROW	100
#define MAX_COL	100
#define NUM_IN	5
#define NUM_OUT 4

ifstream fin;
unsigned int test_data_in[MAX_ROW][MAX_COL];
unsigned int test_data_out[MAX_ROW][MAX_COL];
unsigned short test_data_out_x[MAX_ROW][MAX_COL];

std::string Trim(const std::string &s) {
	std::string::size_type a = s.find_first_not_of(" ");
	return s.substr(a);
}

void read_test_input()
{
	std::string fname = "test_input.txt";
	std::string line;
	std::string subline;
	int c, c1;
	
	// initialize test data
	for(int i = 0; i < MAX_ROW; i++)
		for(int j = 0; j < MAX_COL; j++)
		{
			test_data_in[i][j] = 0;
			test_data_out[i][j] = 0;
			test_data_out_x[i][j] = 0;
		}
		
		// read in test data
	fin.open(fname.c_str());	
	assert(fin.is_open());
	
	getline(fin, line);
	c = 0;
	c1 = 0;
	while(true)
	{
		getline(fin, line);
		if(line.size() == 0)	break;
		
		if(line.find("i_x") != std::string::npos)
		{
			line = line.substr(line.find("i") + 3);
			for(int i = 0; i < NUM_IN; i++)
			{
				subline = Trim(line.substr(0, line.find(":")));
				line = line.substr(line.find(":") + 1);
				assert(subline != "x");
				test_data_in[c][i] = (unsigned int)strtoul(subline.c_str(), NULL, 0);
				// 				std::cout << "i-" << test_data_in[c][i] << " ";
			}
			c++;
			// 			std::cout << std::endl;
		}
		else if(line.find("o_x") != std::string::npos)
		{
			line = line.substr(line.find("o") + 3);
			for(int i = 0; i < NUM_OUT; i++)
			{
				subline = Trim(line.substr(0, line.find(":")));
				line = line.substr(line.find(":") + 1);
				if(subline == "x")
				{
					test_data_out_x[c1][i] = 1;
				}
				else
					test_data_out[c1][i] = (unsigned int)strtoul(subline.c_str(), NULL, 0);
				// 				std::cout << "o-" << test_data_out[c1][i] << test_data_out_x[c1][i];
			}
			c1++;
			// 			std::cout << std::endl;
		}
		else
		{
			//	std::cout << "else: " << line << std::endl;
			//	assert(0);
		}
	}
}
//--------------------------------

void directControl_H::drtCntl(unsigned state)
{
		std::cout << "come to comb " 
	<< state << ":"
	<< HCTxPortGnt << " "
	<< HCTxPortRdy << " "
	<< directControlEn << " "
	<< directControlLineState << " "
	<< rst
	<< std::endl;

  switch (state)
  {
    case START_DC:
      state_drctCntl = CHK_DRCT_CNTL;
      break;
    case CHK_DRCT_CNTL:
      if (directControlEn == true)	
      {
        state_drctCntl = DRCT_CNTL_WAIT_GNT;
      }
      else
      {
        state_drctCntl = IDLE_WAIT_GNT;
      }
      HCTxPortReq = true;
      break;
    case DRCT_CNTL_WAIT_GNT:
      if (HCTxPortGnt == true)	
      {
        state_drctCntl = DRCT_CNTL_WAIT_RDY;
      }
      break;
    case DRCT_CNTL_CHK_LOOP:
      HCTxPortWEn = false;
      if (directControlEn == false)	
      {
        state_drctCntl = CHK_DRCT_CNTL;
        HCTxPortReq = false;
      }
      else
      {
        state_drctCntl = DRCT_CNTL_WAIT_RDY;
      }
      break;
    case DRCT_CNTL_WAIT_RDY:
      if (HCTxPortRdy == true)	
      {
        state_drctCntl = DRCT_CNTL_CHK_LOOP;
        HCTxPortWEn = true;
//         next_HCTxPortData <= {6'b000000, directControlLineState};
        HCTxPortData = directControlLineState;
        HCTxPortCntl = TX_DIRECT_CONTROL;
      }
      break;
    case IDLE_FIN:
      HCTxPortWEn = false;
      HCTxPortReq = false;
      state_drctCntl = CHK_DRCT_CNTL;
      break;
    case IDLE_WAIT_GNT:
      if (HCTxPortGnt == true)	
        state_drctCntl = IDLE_WAIT_RDY;
      break;
    case IDLE_WAIT_RDY:
      if (HCTxPortRdy == true)	
      {
        state_drctCntl = IDLE_FIN;
        HCTxPortWEn = true;
        HCTxPortData = 0;
        HCTxPortCntl = TX_IDLE;
      }
      break;
  }
}

//--------------------------------------------------------------------
// Machine: drctCntl
//--------------------------------------------------------------------
void directControl_H::run()
{
	read_test_input();
	
	int c2 = 0;
  while(true)
  {
		//-------------------------
		HCTxPortGnt = test_data_in[c2][0];
		HCTxPortRdy = test_data_in[c2][1];
		directControlEn = test_data_in[c2][2];
		directControlLineState = test_data_in[c2][3];
		rst = test_data_in[c2][4];
		std::cout << sc_time_stamp() << "i-" 
			<< HCTxPortGnt << " " 
			<< HCTxPortRdy << " " 
			<< directControlEn << " " 
			<< directControlLineState << " " 
			<< rst << std::endl;
		//---------------------------
			
    if (rst)
    {
      state_drctCntl = START_DC;
      HCTxPortCntl = 0;
      HCTxPortData = 0;
      HCTxPortWEn = 0;
      HCTxPortReq = 0;
			drtCntl(state_drctCntl);
    }
    else
      drtCntl(state_drctCntl);

		//-----------------------------
		std::cout << c2 << " o-" << HCTxPortCntl << " " 
		<< HCTxPortData << " " 
		<< HCTxPortReq << " " 
		<< HCTxPortWEn << std::endl;
		if(test_data_out_x[c2][0] == 0)
			assert((unsigned)(HCTxPortCntl) == test_data_out[c2+1][0]);
		if(test_data_out_x[c2][1] == 0)
			assert((unsigned)(HCTxPortData) == test_data_out[c2+1][1]);
		if(test_data_out_x[c2][2] == 0)
			assert((unsigned)(HCTxPortReq) == test_data_out[c2+1][2]);
		if(test_data_out_x[c2][3] == 0)
			assert((unsigned)(HCTxPortWEn) == test_data_out[c2+1][3]);
		c2++;
		if(c2 >= 9)
			break;
		//------------------------------
  }
}

