#include "systemc.h"

// BINARY ENCODED state machine: drctCntl
// State codes definitions:
#define START_DC 0
#define CHK_DRCT_CNTL 1
#define DRCT_CNTL_WAIT_GNT 2
#define DRCT_CNTL_CHK_LOOP 3
#define DRCT_CNTL_WAIT_RDY 4
#define IDLE_FIN 5
#define IDLE_WAIT_GNT 6
#define IDLE_WAIT_RDY 7

#define TX_DIRECT_CONTROL 0
#define TX_IDLE 5

SC_MODULE(directControl_H)
{
  bool		HCTxPortGnt;
  bool		HCTxPortRdy;
  bool		directControlEn;
  unsigned	directControlLineState;
  bool		rst;

  unsigned	HCTxPortCntl;
  unsigned	HCTxPortData;
  bool		HCTxPortReq;
  bool		HCTxPortWEn;

  void run();
  void drtCntl(unsigned);

  unsigned	state_drctCntl;
	
  SC_CTOR(directControl_H)
  {
    SC_THREAD(run);
  }
};
