`include "fft_flpt.v"

module top();
reg [16:0] in_real;
reg [16:0] in_imag;
reg data_valid;
reg data_ack;
reg CLK;

wire [16:0] out_real;
wire [16:0] out_imag;
wire data_req;
wire data_ready;

// Clock generator
always
begin
  #5
  CLK = ~CLK;
end

initial begin
  $dumpfile ("fft_flpt.vcd");
  $dumpvars();
  CLK <= 1'b0;

	repeat(10) begin
		@ (posedge CLK);

		in_real = $random % 17'h1ffff;
		in_imag = $random % 17'h1ffff;
		data_valid = ($random > 0) ? 1'b1 : 1'b0;
		data_ack = ($random > 0) ? 1'b1 : 1'b0;

		$display("%d\ti_x%d:%d:%b:%b:%b:", 
			$time, 
			in_real,
			in_imag,
			data_valid,
			data_ack,
			CLK
		);
		#2
		$display("%d\to_x%d:%d:%b:%b:", 
			$time, 
			out_real,
			out_imag,
			data_req,
			data_ready,
		);
	end
	$finish;
end 

// Connect the DUT
fft U (
	in_real,
	in_imag,
	data_valid,    
	data_ack,
	CLK,
	out_real,
	out_imag,
	data_req,
	data_ready
);

endmodule
