#include <iostream>
#include "hostSlaveMuxBI_H.h"


//sync write demux
void hostSlaveMuxBI_H::sync_write_demux()
{
  if (rstSyncToBusClkOut == true)
  {
    hostMode = false;
  }
  else 
  {
    if (writeEn == true && hostSlaveMuxSel == true && 
      strobe_i == true && address == HOST_SLAVE_CONTROL_REG)
    {
      hostMode = dataIn[0]; 
    }
    
    if (writeEn == true && hostSlaveMuxSel == true && 
      strobe_i == true && address == HOST_SLAVE_CONTROL_REG && (dataIn[1]) == true)
    {
      rstFromBus = true; 
    }
    else
    {
      rstFromBus = false; 
    }
  }
}

// async read mux
void hostSlaveMuxBI_H::async_read_mux(bool addr)
{
  switch(addr)
  {
    case HOST_SLAVE_CONTROL_REG:
      dataOut = 0;
      dataOut[0] = hostMode; 
      break;
    case HOST_SLAVE_VERSION_REG:
      dataOut = USBHOSTSLAVE_VERSION_NUM; 
      break;
  }
}

// reset control
//generate 'rstSyncToBusClk'
//assuming that 'busClk' < 5 * 'usbClk'. ie 'busClk' < 240MHz
void hostSlaveMuxBI_H::reset_control()
{
  if ((rstFromWire == true) || (rstFromBus == true))
  {
    rstShift = 0x3F; 
  }
  else
  {
    rstShift[5] = 0;
    rstShift.range(4, 0) = rstShift.range(5, 1); 
  }
}

void hostSlaveMuxBI_H::rst_shift()
{
  rstSyncToBusClkOut = rstShift[0]; 
}

// double sync across clock domains to generate 'forceEmptySyncToWrClk'
void hostSlaveMuxBI_H::double_sync()
{
  rstSyncToUsbClkFirst = rstSyncToBusClkOut; 
  rstSyncToUsbClkOut = rstSyncToUsbClkFirst; 
}

void hostSlaveMuxBI_H::run()
{
  dataIn = 10;
  address = false;
  writeEn = false;
  strobe_i = false;
  hostSlaveMuxSel = true;
  rstFromWire = true;

  while(true)
  {
    sync_write_demux();
    async_read_mux(address);
    reset_control();
    rst_shift();
    double_sync();
  }
}




