#include <iostream>
#include "hostSlaveMux_H.h"

//--------------------------------
#define MAX_ROW	100
#define MAX_COL	100
#define NUM_IN	20
#define NUM_OUT 9

ifstream fin;
unsigned int test_data_in[MAX_ROW][MAX_COL];
unsigned int test_data_out[MAX_ROW][MAX_COL];
unsigned short test_data_out_x[MAX_ROW][MAX_COL];

std::string Trim(const std::string &s) {
	std::string::size_type a = s.find_first_not_of(" ");
	return s.substr(a);
}

void read_test_input()
{
	std::string fname = "test_input.txt";
	std::string line;
	std::string subline;
	int c, c1;
	
	// initialize test data
	for(int i = 0; i < MAX_ROW; i++)
		for(int j = 0; j < MAX_COL; j++)
		{
			test_data_in[i][j] = 0;
			test_data_out[i][j] = 0;
			test_data_out_x[i][j] = 0;
		}
		
		// read in test data
	fin.open(fname.c_str());	
	assert(fin.is_open());
	
	getline(fin, line);
	c = 0;
	c1 = 0;
	while(true)
	{
		getline(fin, line);
		if(line.size() == 0)	break;
		
		if(line.find("i_x") != std::string::npos)
		{
			line = line.substr(line.find("i") + 3);
			for(int i = 0; i < NUM_IN; i++)
			{
				subline = Trim(line.substr(0, line.find(":")));
				line = line.substr(line.find(":") + 1);
				assert(subline != "x");
				test_data_in[c][i] = (unsigned int)strtoul(subline.c_str(), NULL, 0);
				// 				std::cout << "i-" << test_data_in[c][i] << " ";
			}
			c++;
			// 			std::cout << std::endl;
		}
		else if(line.find("o_x") != std::string::npos)
		{
			line = line.substr(line.find("o") + 3);
			for(int i = 0; i < NUM_OUT; i++)
			{
				subline = Trim(line.substr(0, line.find(":")));
				line = line.substr(line.find(":") + 1);
				if(subline == "x")
				{
					test_data_out_x[c1][i] = 1;
				}
				else
					test_data_out[c1][i] = (unsigned int)strtoul(subline.c_str(), NULL, 0);
				// 				std::cout << "o-" << test_data_out[c1][i] << test_data_out_x[c1][i];
			}
			c1++;
			// 			std::cout << std::endl;
		}
		else
		{
			//	std::cout << "else: " << line << std::endl;
			//	assert(0);
		}
	}
}
//--------------------------------

void hostSlaveMux_H::host_slave_mux(bool ctl)
{
  if (ctl == true) 
  {
    SIEPortCtrlInToSIE = SIEPortCtrlInFromHost; 
    SIEPortDataInToSIE =  SIEPortDataInFromHost; 
    SIEPortWEnToSIE = SIEPortWEnFromHost; 
    fullSpeedPolarityToSIE = fullSpeedPolarityFromHost; 
    fullSpeedBitRateToSIE = fullSpeedBitRateFromHost; 
    noActivityTimeOutEnableToSIE = noActivityTimeOutEnableFromHost; 
  }
  else
  {
    SIEPortCtrlInToSIE = SIEPortCtrlInFromSlave; 
    SIEPortDataInToSIE =  SIEPortDataInFromSlave; 
    SIEPortWEnToSIE = SIEPortWEnFromSlave; 
    fullSpeedPolarityToSIE = fullSpeedPolarityFromSlave; 
    fullSpeedBitRateToSIE = fullSpeedBitRateFromSlave; 
    noActivityTimeOutEnableToSIE = noActivityTimeOutEnableFromSlave; 
  }
}

void hostSlaveMux_H::run()
{
	//---------------------------
	read_test_input();
	int c = 0;
	//----------------------------
	
  while(true)
  {
		//-------------------------

		//-------------------------
		
    ins->dataIn = dataIn;
    ins->address = address;
    ins->writeEn = writeEn;
    ins->strobe_i = strobe_i;
    ins->hostSlaveMuxSel = hostSlaveMuxSel;  
    ins->rstFromWire = rstFromWire;

    dataOut = ins->dataOut;
    hostMode = ins->hostMode;
    rstSyncToBusClkOut = ins->rstSyncToBusClkOut;
    rstSyncToUsbClkOut = ins->rstSyncToUsbClkOut;

    host_slave_mux(hostMode);
		
		//-------------------------
		
		//-------------------------
  }  
}

