#include "systemc.h"
#include "usbHostSlave.h"

SC_MODULE(hostSlaveMuxBI_L)
{
  sc_in<sc_uint<8> > dataIn;
  sc_in<bool> address;
  sc_in<bool> writeEn;
  sc_in<bool> strobe_i;
  sc_in<bool> busClk;
  sc_in<bool> usbClk;
  sc_out<sc_uint<8> > dataOut;
  sc_in<bool> hostSlaveMuxSel;
  sc_out<bool> hostMode;
  sc_in<bool> rstFromWire;
  sc_out<bool> rstSyncToBusClkOut;
  sc_out<bool> rstSyncToUsbClkOut;

  void sync_write_demux();
  void async_read_mux();
  void reset_control();
  void rst_shift();
  void double_sync();
	
  //internal wire and regs
  sc_signal<sc_uint<6> > rstShift;
  sc_signal<bool> rstFromBus;
  sc_signal<bool> rstSyncToUsbClkFirst;

  SC_CTOR(hostSlaveMuxBI_L)
  {
    SC_METHOD(sync_write_demux);
    sensitive << busClk.pos();

    SC_METHOD(async_read_mux);
    sensitive << address << hostMode;

    SC_METHOD(reset_control);
    sensitive << busClk.pos();

    SC_METHOD(rst_shift);
    sensitive << rstShift;

    SC_METHOD(double_sync);
    sensitive << usbClk.pos();
  }
};
