#include <systemc>
#include <iostream>
#include "hostSlaveMux_L.h"

SC_MODULE(testt)
{
  sc_out<sc_uint<8> > SIEPortCtrlInFromHost;
  sc_out<sc_uint<8> > SIEPortCtrlInFromSlave;
  sc_out<sc_uint<8> > SIEPortDataInFromHost; 
  sc_out<sc_uint<8> > SIEPortDataInFromSlave; 
  sc_out<bool> SIEPortWEnFromHost; 
  sc_out<bool> SIEPortWEnFromSlave; 
  sc_out<bool> fullSpeedPolarityFromHost;
  sc_out<bool> fullSpeedPolarityFromSlave;
  sc_out<bool> fullSpeedBitRateFromHost;
  sc_out<bool> fullSpeedBitRateFromSlave;
  sc_out<bool> noActivityTimeOutEnableFromHost;
  sc_out<bool> noActivityTimeOutEnableFromSlave;

 //hostSlaveMuxBI
  sc_out<sc_uint<8> > dataIn;
  sc_out<bool> address;
  sc_out<bool> writeEn;
  sc_out<bool> strobe_i;
  sc_out<bool> busClk;
  sc_out<bool> usbClk;
  sc_out<bool> rstFromWire;
  sc_out<bool> hostSlaveMuxSel;

  void stimuli()
	{
		rstFromWire.write(true);

		SIEPortCtrlInFromHost.write(3);
		SIEPortCtrlInFromSlave.write(4);
		SIEPortDataInFromHost.write(5);
		SIEPortDataInFromSlave.write(6);

		SIEPortWEnFromHost.write(false);
		SIEPortWEnFromSlave.write(false);
		fullSpeedPolarityFromHost.write(false);
		fullSpeedPolarityFromSlave.write(false);
		fullSpeedBitRateFromHost.write(false);
		fullSpeedBitRateFromSlave.write(false);
		noActivityTimeOutEnableFromHost.write(false);
		noActivityTimeOutEnableFromSlave.write(false);

		dataIn.write(7);

		address.write(false);
		writeEn.write(false);
		strobe_i.write(false);
		hostSlaveMuxSel.write(false);

		wait(10, SC_NS); 
		rstFromWire.write(false);

		wait(10, SC_NS); 
		SIEPortWEnFromHost.write(true);
		fullSpeedPolarityFromHost.write(true);
		fullSpeedBitRateFromHost.write(true);
		noActivityTimeOutEnableFromHost.write(true);

		wait(10, SC_NS); 
		SIEPortWEnFromSlave.write(true);
		fullSpeedPolarityFromSlave.write(true);
		fullSpeedBitRateFromSlave.write(true);
		noActivityTimeOutEnableFromSlave.write(true);

		wait(10, SC_NS); 
		SIEPortWEnFromHost.write(false);
		fullSpeedPolarityFromHost.write(false);
		fullSpeedBitRateFromHost.write(false);
		noActivityTimeOutEnableFromHost.write(false);

		wait(10, SC_NS); 
		address.write(true);
		writeEn.write(true);

		wait(10, SC_NS); 
		strobe_i.write(true);
		rstFromWire.write(true);
		hostSlaveMuxSel.write(true);

		wait(10, SC_NS); 
		writeEn.write(false);

		wait(10, SC_NS); 
		strobe_i.write(false);
		rstFromWire.write(false);

		wait(10, SC_NS); 
		hostSlaveMuxSel.write(false);

		wait(20, SC_NS); 
		sc_stop();
	}

  void clk_gen()
	{
		while(true) {
			usbClk.write(false);
			busClk.write(true);
			wait(5, SC_NS);
			usbClk.write(true);
			busClk.write(false);
			wait(5, SC_NS);
		}
	}

  SC_CTOR(testt) 
  {
    SC_THREAD(stimuli);
    SC_THREAD(clk_gen);
  }
};

SC_MODULE(monitor)
{
  sc_in<sc_uint<8> > SIEPortCtrlInToSIE;
  sc_in<sc_uint<8> > SIEPortCtrlInFromHost;
  sc_in<sc_uint<8> > SIEPortCtrlInFromSlave;
  sc_in<sc_uint<8> > SIEPortDataInToSIE; 
  sc_in<sc_uint<8> > SIEPortDataInFromHost; 
  sc_in<sc_uint<8> > SIEPortDataInFromSlave; 
  sc_in<bool> SIEPortWEnToSIE; 
  sc_in<bool> SIEPortWEnFromHost; 
  sc_in<bool> SIEPortWEnFromSlave; 
  sc_in<bool> fullSpeedPolarityToSIE;
  sc_in<bool> fullSpeedPolarityFromHost;
  sc_in<bool> fullSpeedPolarityFromSlave;
  sc_in<bool> fullSpeedBitRateToSIE;
  sc_in<bool> fullSpeedBitRateFromHost;
  sc_in<bool> fullSpeedBitRateFromSlave;
  sc_in<bool> noActivityTimeOutEnableToSIE;
  sc_in<bool> noActivityTimeOutEnableFromHost;
  sc_in<bool> noActivityTimeOutEnableFromSlave;
 
 //hostSlaveMuxBI
  sc_in<sc_uint<8> > dataIn;
  sc_in<bool> address;
  sc_in<bool> writeEn;
  sc_in<bool> strobe_i;
  sc_in<bool> busClk;
  sc_in<bool> usbClk;
  sc_in<bool> rstFromWire;
  sc_in<bool> rstSyncToBusClkOut;
  sc_in<bool> rstSyncToUsbClkOut;
  sc_in<sc_uint<8> > dataOut;
  sc_in<bool> hostSlaveMuxSel;

  void MonGen()
  {
    std::cout << sc_time_stamp() << " " << SIEPortCtrlInFromHost << " " << SIEPortCtrlInFromSlave << " " 
	    << SIEPortDataInFromHost << " " << SIEPortDataInFromSlave << " " 
	    << SIEPortWEnFromHost << " " << SIEPortWEnFromSlave << " "
	    << fullSpeedPolarityFromHost << " " << fullSpeedPolarityFromSlave << " "
	    << fullSpeedBitRateFromHost << " " << fullSpeedBitRateFromSlave << " " 
	    << noActivityTimeOutEnableFromHost << " " << noActivityTimeOutEnableFromSlave << " " 
	    << dataIn << " " << address << " " << writeEn << " " << strobe_i << " " << busClk << " " << usbClk << " "
	    << hostSlaveMuxSel << " " << rstFromWire << " \t" 
	    << SIEPortCtrlInToSIE << " " << SIEPortDataInToSIE << " " << SIEPortWEnToSIE << " " 
	    << fullSpeedPolarityToSIE << " " << fullSpeedBitRateToSIE << " " << noActivityTimeOutEnableToSIE << " " 
	    << rstSyncToBusClkOut << " " << rstSyncToUsbClkOut << " " << dataOut << " " << std::endl;
  }

  SC_CTOR(monitor)
  {
    SC_METHOD(MonGen);
    sensitive << usbClk.pos() << busClk.pos();
  }
};

// here it goes.
int sc_main(int argc, char *argv[])
{
  sc_set_time_resolution(1, SC_NS);
  sc_signal<sc_uint<8> > SIEPortCtrlInToSIE;
  sc_signal<sc_uint<8> > SIEPortCtrlInFromHost;
  sc_signal<sc_uint<8> > SIEPortCtrlInFromSlave;
  sc_signal<sc_uint<8> > SIEPortDataInToSIE; 
  sc_signal<sc_uint<8> > SIEPortDataInFromHost; 
  sc_signal<sc_uint<8> > SIEPortDataInFromSlave; 
  sc_signal<bool> SIEPortWEnToSIE; 
  sc_signal<bool> SIEPortWEnFromHost; 
  sc_signal<bool> SIEPortWEnFromSlave; 
  sc_signal<bool> fullSpeedPolarityToSIE;
  sc_signal<bool> fullSpeedPolarityFromHost;
  sc_signal<bool> fullSpeedPolarityFromSlave;
  sc_signal<bool> fullSpeedBitRateToSIE;
  sc_signal<bool> fullSpeedBitRateFromHost;
  sc_signal<bool> fullSpeedBitRateFromSlave;
  sc_signal<bool> noActivityTimeOutEnableToSIE;
  sc_signal<bool> noActivityTimeOutEnableFromHost;
  sc_signal<bool> noActivityTimeOutEnableFromSlave;
  sc_signal<sc_uint<8> > dataIn;
  sc_signal<bool> address;
  sc_signal<bool> writeEn;
  sc_signal<bool> strobe_i;
  sc_signal<bool> busClk;
  sc_signal<bool> usbClk;
  sc_signal<bool> rstFromWire;
  sc_signal<bool> rstSyncToBusClkOut;
  sc_signal<bool> rstSyncToUsbClkOut;
  sc_signal<sc_uint<8> > dataOut;
  sc_signal<bool> hostSlaveMuxSel;


	hostSlaveMux_L ins("ins");
	ins.SIEPortCtrlInToSIE(SIEPortCtrlInToSIE);
	ins.SIEPortCtrlInFromHost(SIEPortCtrlInFromHost);
	ins.SIEPortCtrlInFromSlave(SIEPortCtrlInFromSlave);
	ins.SIEPortDataInToSIE(SIEPortDataInToSIE);
	ins.SIEPortDataInFromHost(SIEPortDataInFromHost);
	ins.SIEPortDataInFromSlave(SIEPortDataInFromSlave);
	ins.SIEPortWEnToSIE(SIEPortWEnToSIE);
	ins.SIEPortWEnFromHost(SIEPortWEnFromHost);
	ins.SIEPortWEnFromSlave(SIEPortWEnFromSlave);
	ins.fullSpeedPolarityToSIE(fullSpeedPolarityToSIE);
	ins.fullSpeedPolarityFromHost(fullSpeedPolarityFromHost);
	ins.fullSpeedPolarityFromSlave(fullSpeedPolarityFromSlave);
	ins.fullSpeedBitRateToSIE(fullSpeedBitRateToSIE);
	ins.fullSpeedBitRateFromHost(fullSpeedBitRateFromHost);
	ins.fullSpeedBitRateFromSlave(fullSpeedBitRateFromSlave);
	ins.noActivityTimeOutEnableToSIE(noActivityTimeOutEnableToSIE);
	ins.noActivityTimeOutEnableFromHost(noActivityTimeOutEnableFromHost);
	ins.noActivityTimeOutEnableFromSlave(noActivityTimeOutEnableFromSlave);
	ins.dataIn(dataIn);
	ins.address(address);
	ins.writeEn(writeEn);
	ins.strobe_i(strobe_i);
	ins.busClk(busClk);
	ins.usbClk(usbClk);
	ins.rstFromWire(rstFromWire);
	ins.rstSyncToBusClkOut(rstSyncToBusClkOut);
	ins.rstSyncToUsbClkOut(rstSyncToUsbClkOut);
	ins.dataOut(dataOut);
	ins.hostSlaveMuxSel(hostSlaveMuxSel);

	testt tb("tester");
	tb.SIEPortCtrlInFromHost(SIEPortCtrlInFromHost);
	tb.SIEPortCtrlInFromSlave(SIEPortCtrlInFromSlave);
	tb.SIEPortDataInFromHost(SIEPortDataInFromHost);
	tb.SIEPortDataInFromSlave(SIEPortDataInFromSlave);
	tb.SIEPortWEnFromHost(SIEPortWEnFromHost);
	tb.SIEPortWEnFromSlave(SIEPortWEnFromSlave);
	tb.fullSpeedPolarityFromHost(fullSpeedPolarityFromHost);
	tb.fullSpeedPolarityFromSlave(fullSpeedPolarityFromSlave);
	tb.fullSpeedBitRateFromHost(fullSpeedBitRateFromHost);
	tb.fullSpeedBitRateFromSlave(fullSpeedBitRateFromSlave);
	tb.noActivityTimeOutEnableFromHost(noActivityTimeOutEnableFromHost);
	tb.noActivityTimeOutEnableFromSlave(noActivityTimeOutEnableFromSlave);
	tb.dataIn(dataIn);
	tb.address(address);
	tb.writeEn(writeEn);
	tb.strobe_i(strobe_i);
	tb.busClk(busClk);
	tb.usbClk(usbClk);
	tb.rstFromWire(rstFromWire);
	tb.hostSlaveMuxSel(hostSlaveMuxSel);

	monitor mon("monitor");
	mon.SIEPortCtrlInToSIE(SIEPortCtrlInToSIE);
	mon.SIEPortCtrlInFromHost(SIEPortCtrlInFromHost);
	mon.SIEPortCtrlInFromSlave(SIEPortCtrlInFromSlave);
	mon.SIEPortDataInToSIE(SIEPortDataInToSIE);
	mon.SIEPortDataInFromHost(SIEPortDataInFromHost);
	mon.SIEPortDataInFromSlave(SIEPortDataInFromSlave);
	mon.SIEPortWEnToSIE(SIEPortWEnToSIE);
	mon.SIEPortWEnFromHost(SIEPortWEnFromHost);
	mon.SIEPortWEnFromSlave(SIEPortWEnFromSlave);
	mon.fullSpeedPolarityToSIE(fullSpeedPolarityToSIE);
	mon.fullSpeedPolarityFromHost(fullSpeedPolarityFromHost);
	mon.fullSpeedPolarityFromSlave(fullSpeedPolarityFromSlave);
	mon.fullSpeedBitRateToSIE(fullSpeedBitRateToSIE);
	mon.fullSpeedBitRateFromHost(fullSpeedBitRateFromHost);
	mon.fullSpeedBitRateFromSlave(fullSpeedBitRateFromSlave);
	mon.noActivityTimeOutEnableToSIE(noActivityTimeOutEnableToSIE);
	mon.noActivityTimeOutEnableFromHost(noActivityTimeOutEnableFromHost);
	mon.noActivityTimeOutEnableFromSlave(noActivityTimeOutEnableFromSlave);
	mon.dataIn(dataIn);
	mon.address(address);
	mon.writeEn(writeEn);
	mon.strobe_i(strobe_i);
	mon.busClk(busClk);
	mon.usbClk(usbClk);
	mon.rstFromWire(rstFromWire);
	mon.rstSyncToBusClkOut(rstSyncToBusClkOut);
	mon.rstSyncToUsbClkOut(rstSyncToUsbClkOut);
	mon.dataOut(dataOut);
	mon.hostSlaveMuxSel(hostSlaveMuxSel);

  sc_trace_file *tf;
  tf = sc_create_vcd_trace_file("trace");

  sc_trace(tf, SIEPortCtrlInToSIE, "SIEPortCtrlInToSIE");
  sc_trace(tf, SIEPortCtrlInFromHost, "SIEPortCtrlInFromHost");
  sc_trace(tf, SIEPortCtrlInFromSlave, "SIEPortCtrlInFromSlave");

  sc_trace(tf, SIEPortDataInToSIE, "SIEPortDataInToSIE");
  sc_trace(tf, SIEPortDataInFromHost, "SIEPortDataInFromHost");
  sc_trace(tf, SIEPortDataInFromSlave, "SIEPortDataInFromSlave");

  sc_trace(tf, SIEPortWEnToSIE, "SIEPortWEnToSIE");
  sc_trace(tf, SIEPortWEnFromHost, "SIEPortWEnFromHost");
  sc_trace(tf, SIEPortWEnFromSlave, "SIEPortWEnFromSlave");

  sc_trace(tf, fullSpeedPolarityToSIE, "fullSpeedPolarityToSIE");
  sc_trace(tf, fullSpeedPolarityFromHost, "fullSpeedPolarityFromHost");
  sc_trace(tf, fullSpeedPolarityFromSlave, "fullSpeedPolarityFromSlave");

  sc_trace(tf, fullSpeedBitRateToSIE, "fullSpeedBitRateToSIE");
  sc_trace(tf, fullSpeedBitRateFromHost, "fullSpeedBitRateFromHost");
  sc_trace(tf, fullSpeedBitRateFromSlave, "fullSpeedBitRateFromSlave");

  sc_trace(tf, noActivityTimeOutEnableToSIE, "noActivityTimeOutEnableToSIE");
  sc_trace(tf, noActivityTimeOutEnableFromHost, "noActivityTimeOutEnableFromHost");
  sc_trace(tf, noActivityTimeOutEnableFromSlave, "noActivityTimeOutEnableFromSlave");

  sc_trace(tf, dataIn, "dataIn");
  sc_trace(tf, address, "address");
  sc_trace(tf, writeEn, "writeEn");
  sc_trace(tf, strobe_i, "strobe_i");
  sc_trace(tf, busClk, "busClk");
  sc_trace(tf, usbClk, "usbClk");
  sc_trace(tf, rstFromWire, "rstFromWire");
  sc_trace(tf, rstSyncToBusClkOut, "rstSyncToBusClkOut");
  sc_trace(tf, rstSyncToUsbClkOut, "rstSyncToUsbClkOut");
  sc_trace(tf, dataOut, "dataOut");
  sc_trace(tf, hostSlaveMuxSel, "hostSlaveMuxSel");

  sc_start(1000, SC_NS);
  sc_close_vcd_trace_file(tf);

  return 0;
}

