#include "systemc.h"
#include "hostSlaveMuxBI_H.h"

SC_MODULE(hostSlaveMux_H)
{
  sc_uint<8>  SIEPortCtrlInToSIE;
  sc_uint<8>  SIEPortCtrlInFromHost;
  sc_uint<8>  SIEPortCtrlInFromSlave;
  sc_uint<8>  SIEPortDataInToSIE; 
  sc_uint<8>  SIEPortDataInFromHost; 
  sc_uint<8>  SIEPortDataInFromSlave; 
  bool SIEPortWEnToSIE; 
  bool SIEPortWEnFromHost; 
  bool SIEPortWEnFromSlave; 
  bool fullSpeedPolarityToSIE;
  bool fullSpeedPolarityFromHost;
  bool fullSpeedPolarityFromSlave;
  bool fullSpeedBitRateToSIE;
  bool fullSpeedBitRateFromHost;
  bool fullSpeedBitRateFromSlave;
  bool noActivityTimeOutEnableToSIE;
  bool noActivityTimeOutEnableFromHost;
  bool noActivityTimeOutEnableFromSlave;
 
 //hostSlaveMuxBI
  sc_uint<8>  dataIn;
  bool address;
  bool writeEn;
  bool strobe_i;
  bool busClk;
  bool usbClk;
  bool rstFromWire;
  bool hostSlaveMuxSel;
  bool rstSyncToBusClkOut;
  bool rstSyncToUsbClkOut;
  sc_uint<8>  dataOut;

  void host_slave_mux(bool);
  void show();
  void run();

  hostSlaveMuxBI_H *ins;
  //internal wires and regs
  bool hostMode;

  SC_CTOR(hostSlaveMux_H)
  {
    SC_THREAD(run);
  }
};

#include <iostream>
#include "hostSlaveMux_H.h"

void hostSlaveMux_H::show()
{
std::cout << sc_time_stamp() << " " << SIEPortCtrlInFromHost << " " << SIEPortCtrlInFromSlave << " " 
	    << SIEPortDataInFromHost << " " << SIEPortDataInFromSlave << " " 
	    << SIEPortWEnFromHost << " " << SIEPortWEnFromSlave << " "
	    << fullSpeedPolarityFromHost << " " << fullSpeedPolarityFromSlave << " "
	    << fullSpeedBitRateFromHost << " " << fullSpeedBitRateFromSlave << " " 
	    << noActivityTimeOutEnableFromHost << " " << noActivityTimeOutEnableFromSlave << " " 
	    << dataIn << " " << address << " " << writeEn << " " << strobe_i << " " << busClk << " " << usbClk << " "
	    << hostSlaveMuxSel << " " << rstFromWire << " \t" 
	    << SIEPortCtrlInToSIE << " " << SIEPortDataInToSIE << " " << SIEPortWEnToSIE << " " 
	    << fullSpeedPolarityToSIE << " " << fullSpeedBitRateToSIE << " " << noActivityTimeOutEnableToSIE << " " 
	    << rstSyncToBusClkOut << " " << rstSyncToUsbClkOut << " " << dataOut << " " << std::endl;
}

void hostSlaveMux_H::host_slave_mux(bool ctl)
{
  if (ctl == true) 
  {
    SIEPortCtrlInToSIE = SIEPortCtrlInFromHost; 
    SIEPortDataInToSIE =  SIEPortDataInFromHost; 
    SIEPortWEnToSIE = SIEPortWEnFromHost; 
    fullSpeedPolarityToSIE = fullSpeedPolarityFromHost; 
    fullSpeedBitRateToSIE = fullSpeedBitRateFromHost; 
    noActivityTimeOutEnableToSIE = noActivityTimeOutEnableFromHost; 
  }
  else
  {
    SIEPortCtrlInToSIE = SIEPortCtrlInFromSlave; 
    SIEPortDataInToSIE =  SIEPortDataInFromSlave; 
    SIEPortWEnToSIE = SIEPortWEnFromSlave; 
    fullSpeedPolarityToSIE = fullSpeedPolarityFromSlave; 
    fullSpeedBitRateToSIE = fullSpeedBitRateFromSlave; 
    noActivityTimeOutEnableToSIE = noActivityTimeOutEnableFromSlave; 
  }
}

void hostSlaveMux_H::run()
{
  while(true)
  {
    show();
    ins->dataIn = dataIn;
    ins->address = address;
    ins->writeEn = writeEn;
    ins->strobe_i = strobe_i;
    ins->hostSlaveMuxSel = hostSlaveMuxSel;  
    ins->rstFromWire = rstFromWire;

    dataOut = ins->dataOut;
    hostMode = ins->hostMode;
    rstSyncToBusClkOut = ins->rstSyncToBusClkOut;
    rstSyncToUsbClkOut = ins->rstSyncToUsbClkOut;

    host_slave_mux(hostMode);
  }  
}


