module dcache (datain, cs, we, addr, dout, out_valid, wr_ack, CLK);
input [31:0] datain;
input cs;
input we;
input [31:0] addr;
input CLK;

output [31:0] dout;
output out_valid;
output wr_ack;

`define DCACHE_SIZE 4096

reg [31:0] dout;
reg out_valid;
reg wr_ack;

reg [31:0] wait_cycles;
reg [31:0] dmemory[0:`DCACHE_SIZE-1];
reg [31:0] address;

initial
begin
	wait_cycles = 2;
end

always @(posedge CLK)
begin
	if(cs == 1)
	begin
		address = addr;
		if(we == 1)
		begin 
			#2;
			dmemory[address] = datain;
			wr_ack = 1;
			#1;
			wr_ack = 0;
		end
		else
		begin
			#2;
			dout = dmemory[address];
			out_valid = 1;
			#1;
			out_valid = 0;
		end
	end
end
endmodule
