`include "dcache.v"

module top();

reg [31:0] datain;
reg cs;
reg we;
reg [31:0] addr;
reg CLK;

wire [31:0] dout;
wire out_valid;
wire wr_ack;

// Clock generator
always begin
  #5 
  CLK = ~CLK;
end

initial
begin
  $dumpfile("dcache.vcd");
  $dumpvars();

	CLK <= 0;

	repeat(10) begin
		@ (posedge CLK);

		datain = $random;
		cs = ($random > 0) ? 1'b1 : 1'b0;
		we = ($random > 0) ? 1'b1 : 1'b0;
		addr = $random;

		$display("%d\ti_x%d:%b:%b:%d:", 
			$time, 
			datain,
			cs,
			we,
			addr
		);
		#5
		$display("%d\to_x%d:%b:%b:", 
			$time, 
			dout,
			out_valid,
			wr_ack
		);
	end
	$finish;
end

dcache U(
	datain,
	cs,
	we,
	addr,
	dout,
	out_valid,
	wr_ack,
  CLK
);

endmodule
