/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.

  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with such restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.

 *****************************************************************************/

/*****************************************************************************
 
  exec.cpp -- Integer Execution Unit.
 
  Original Author: Martin Wang, Synopsys, Inc.
 
 *****************************************************************************/
 
/*****************************************************************************
 
  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.
 
      Name, Affiliation, Date:
  Description of Modification:
 
 *****************************************************************************/


#include "systemc.h"

SC_MODULE(exec_H)
{
  bool   	       	reset;			// reset not used.
  bool   	       	cs;		      // chip select
  sc_uint<8>    	opcode;			// opcode from ID
  sc_int<32>      dina;			// operand A
  sc_int<32>      dinb;			// operand B
  bool              	C;			// Carry bit 
  bool              	V;			// Overflow bit
  bool              	Z;			// Zero bit
  sc_int<32>         	dout;			// output data
  bool   	       	out_valid;		// output valid
  
  void run_exec();
	void run();
	
  SC_CTOR(exec_H) {
      SC_THREAD(run);
  }
};


