`include "exec.v"

module top();

reg reset;
reg cs;
reg [7:0] opcode;
reg [31:0] dina;
reg [31:0] dinb;
reg CLK;

wire C;
wire V;
wire Z;
wire [31:0] dout;
wire out_valid;

reg reset_tmp;

// Clock generator
always begin
  #5 
  CLK = ~CLK;
end

initial
begin
  $dumpfile("exec.vcd");
  $dumpvars();
  reset_tmp = 1'b0;
  reset = 1'b1;

	CLK <= 0;

	repeat(10) begin
		@ (posedge CLK);
		
		if(reset_tmp == 1'b1)
			reset = 1'b0;
		if(reset_tmp == 1'b0)
			reset_tmp = 1'b1;

		dina = $random;
		cs = ($random > 0) ? 1'b1 : 1'b0;
		dinb = $random;
		opcode = $random % 256;

		$display("%d\ti_x%d:%b:%d:%d:", 
			$time, 
			dina,
			cs,
			dinb,
			opcode
		);
		#7
		$display("%d\to_x%b:%b:%b:%d:%b:", 
			$time, 
			C,
			V,
			Z,
			dout,
			out_valid
		);
	end
	$finish;
end

exec U(
	reset,
	cs,
	opcode,
	dina,
	dinb,
	C,
	V,
  Z,
	dout,
	out_valid,
	CLK
);

endmodule
