module fetch(ramdata, 
		branch_address, 
		next_pc, 
		branch_valid, 
		interrupt, 
		int_vectno, 
		ram_valid, 
		CLK,
		ram_cs,
		address,
		instruction,
		instruction_valid,
		program_counter,
		interrupt_ack,
		branch_clear,
		reset);
input	[31:0] ramdata;
input	[31:0] branch_address;
input	 next_pc;
input	 branch_valid;
input	 interrupt;
input	[31:0] int_vectno;
input ram_valid;
input CLK;

output ram_cs;
output [31:0] address;
output [31:0] instruction;
output instruction_valid;
output [31:0] program_counter;
output interrupt_ack;
output branch_clear;
output reset;

reg ram_cs;
reg [31:0] address;
reg [31:0] instruction;
reg instruction_valid;
reg [31:0] program_counter;
reg interrupt_ack;
reg branch_clear;
reg reset;

reg [31:0] memory_latency;

reg [31:0] addr_tmp = 0;
reg [31:0] datao_tmp = 0;
reg [31:0] datai_tmp = 0;

initial
begin
	addr_tmp = 0;
	datao_tmp = 32'hdeadbeef;

	reset = 1;
	ram_cs = 1;
	address = addr_tmp;

	wait(ram_valid == 1) begin
		instruction_valid = 1;
		instruction = datai_tmp;
		program_counter = addr_tmp;
		ram_cs = 0;
		#1;
		instruction_valid = 0;
		addr_tmp = addr_tmp + 1;
	end
end

always @ (posedge CLK)
begin
	if(addr_tmp == 5)
		reset = 0;

	if(interrupt == 1)
	begin
		ram_cs = 1;
		addr_tmp = int_vectno;
		//wait(memory_latency) ** to be done
		datai_tmp = ramdata;

		instruction_valid = 1;
		instruction = datai_tmp;
		ram_cs = 0;
		interrupt_ack = 1;
		if(next_pc == 1)
			addr_tmp = addr_tmp + 1;
		#1;
		instruction_valid = 0;
		interrupt_ack = 0;
		#1;
	end

	if(branch_valid == 1)
		addr_tmp = branch_address;
	else
		addr_tmp = addr_tmp + 1;

	ram_cs = 1;
	address = addr_tmp;

	wait(ram_valid == 1) begin
		datai_tmp = ramdata;

		instruction_valid = 1;
		instruction = datai_tmp;
		program_counter = addr_tmp;
		ram_cs = 0;
		#1;
		instruction_valid = 0;
		wait(next_pc == 1) #1;
	end
end
endmodule
