`include "icache.v"

module top();

reg cs;
reg [31:0] addr;
reg ld_valid;
reg [31:0] ld_data;
reg CLK;

wire [31:0] dataout;
wire icache_valid;

// Clock generator
always begin
  #5 
  CLK = ~CLK;
end

initial
begin
  $dumpfile("icache.vcd");
  $dumpvars();

	CLK <= 0;

	repeat(10) begin
		@ (posedge CLK);
		
		cs = ($random > 0) ? 1'b1 : 1'b0;
		addr = $random;
		ld_valid = ($random > 0) ? 1'b1 : 1'b0;
		ld_data = $random;

		$display("%d\ti_x%b:%d:%b:%d:", 
			$time, 
			cs,
			addr,
			ld_valid,
			ld_data
		);
		#7
		$display("%d\to_x%d:%b:", 
			$time, 
			dataout,
			icache_valid
		);
	end
	$finish;
end

icache U(
	cs,
	addr,
	ld_valid,
	ld_data,
	dataout,
	icache_valid,
	CLK
);

endmodule
