module paging(csin, 
		logical_address, 
		icache_din, 
		icache_validin, 
		bios_din, 
		bios_validin,
		CLK,
		dout,
		icache_csout,
		bios_csout,
		physical_address,
		data_valid);
input csin;
input [31:0] logical_address;
input [31:0] icache_din;
input icache_validin;
input [31:0] bios_din;
input bios_validin;
input CLK;

output [31:0] dout;
output icache_csout;
output bios_csout;
output [31:0] physical_address;
output data_valid;

reg [31:0] dout;
reg icache_csout;
reg bios_csout;
reg [31:0] physical_address;
reg data_valid;

reg [31:0] pid_reg;
reg [31:0] address;

initial
begin
	address = 0;
end

always @(posedge CLK)
begin
	if(csin == 1'b1)
	begin
		address = logical_address;

		if(address >= 5)
		begin
			physical_address = logical_address;
			icache_csout = 1;
			#1;

			wait(icache_validin == 1)
			begin
				dout = icache_din;
				data_valid = 1;
				icache_csout = 0;
				#1;
				data_valid = 0;
				#1;
			end
		end
		else
		begin
			physical_address = logical_address;
			bios_csout = 1;
			#1;
			
			wait(bios_validin == 1)
			begin
				dout = bios_din;
				data_valid = 1;
				bios_csout = 0;
				#1;
				data_valid = 0;
				#1;
			end
		end
	end
	else
	begin
		#1;
	end
end 
endmodule
