`include "paging.v"

module top();

reg csin;
reg [31:0] logical_address;
reg [31:0] icache_din;
reg icache_validin;
reg [31:0] bios_din;
reg bios_validin;
reg CLK;

wire [31:0] dout;
wire icache_csout;
wire bios_csout;
wire [31:0] physical_address;
wire data_valid;

// Clock generator
always begin
  #5 
  CLK = ~CLK;
end

initial
begin
  $dumpfile("paging.vcd");
  $dumpvars();

	CLK <= 0;

	repeat(10) begin
		@ (posedge CLK);

		csin = ($random > 0) ? 1'b1 : 1'b0;
		logical_address = $random;
		icache_din = $random;
		icache_validin = ($random > 0) ? 1'b1 : 1'b0;
		bios_din = $random;
		bios_validin = ($random > 0) ? 1'b1 : 1'b0;

		$display("%d\ti_x%b:%d:%d:%b:%d:%b:", 
			$time, 
			csin,
			logical_address,
			icache_din,
			icache_validin,
			bios_din,
			bios_validin
		);
		#7
		$display("%d\to_x%d:%b:%b:%d:%b:", 
			$time, 
			dout,
			icache_csout,
			bios_csout,
			physical_address,
			data_valid
		);
	end
	$finish;
end

paging U(
	csin,
		logical_address, 
		icache_din, 
		icache_validin, 
		bios_din, 
		bios_validin,
		CLK,
		dout,
		icache_csout,
		bios_csout,
		physical_address,
		data_valid
);

endmodule
