/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.

  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with such restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.

 *****************************************************************************/

/*****************************************************************************
 
  pic_h.cpp -- Programmable Interrupt Unit.
 
  Original Author: Martin Wang, Synopsys, Inc.
 
 *****************************************************************************/
 
/*****************************************************************************
 
  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.

      Name, Affiliation, Date:
  Description of Modification:
 
 *****************************************************************************/

#include "systemc.h"

struct pic_h : sc_module { 
	bool  		ireq0; 		// interrupt request 0   	
	bool  		ireq1;    	// interrupt request 1
	bool  		ireq2;    	// interrupt request 2
	bool  		ireq3;    	// interrupt request 3
	bool  		cs;    		// chip select
	bool  		rd_wr;    	// read or write
	bool  		intack_cpu;    	// interrupt acknowledge from CPU
	bool  		intreq;         // interrupt request to CPU		
	bool  		intack;         // interrupt acknowledge to devices		
	sc_uint<32>  vectno;         // vector number		

  //Constructor 
  SC_CTOR(pic_h) {
		SC_THREAD(run);
  }
  // Process functionality in member function below
  void run();
};

void pic_h::run()
{
	while(true)
	{
		if (ireq0 == true) 
		{
			intreq = true;
			vectno = 0;
		} 
		else if (ireq1 == true) 
		{
			intreq = true;
			vectno = 1;
		}
		else if (ireq2 == true) 
		{
			intreq = true;
			vectno = 2;
		} 
		else if (ireq3 == true) 
		{
			intreq = true;
			vectno = 2;
		} 
		else 
		{} 
		
		if ((intack_cpu == true) && (cs == true)) 
		{
			intreq = false;
		}
	}
}

// EOF

