`include "registerfile.v"

module top ();

reg clk;
reg rst;
reg cs;
reg re;
reg we;
reg [3:0] addr1;
reg [3:0] addr2;
reg [3:0] addr3;
reg [31:0] data3;

wire [31:0] data1;
wire [31:0] data2;

reg rst_tmp;

// Clock generator
always
begin
  #5
  clk = ~clk;
end

initial begin
  $dumpfile ("registerfile.vcd");
  $dumpvars();
  rst <= 1'b1;
  clk <= 1'b0;
	rst_tmp <= 1'b0;

	repeat(10) begin
		@ (posedge clk);

		if(rst_tmp == 1'b1)
		begin
			rst = 1'b0;
		end

		if(rst_tmp == 1'b0)
		begin
			rst_tmp = 1'b1;
		end

		cs = ($random > 0) ? 1'b1 : 1'b0;
		re = ($random > 0) ? 1'b1 : 1'b0;
		we = ($random > 0) ? 1'b1 : 1'b0;
		addr1 = $random % 16;
		addr2 = $random % 16;
		addr3 = $random % 16;
		data3 = $random;

		$display("%d\ti_x%b:%b:%b:%b:%d:%d:%d:%d:", 
			$time, 
			rst,
			cs,
			re,
			we,
			addr1,
			addr2,
			addr3,
			data3
		);
		#2
		$display("%d\to_x%d:%d:", 
			$time, 
			data1,
			data2
		);
	end
	$finish;
end 

// Connect the DUT
registerfile U (
	clk,
	rst,
	cs,    
	re,
	we,
	addr1,
	addr2,
	addr3,
	data3,
	data1,
	data2
);

endmodule
