#include <iostream>
#include "usbTxWireArbiter_L.h"

//--------------------------------
// processTxByte/SIETransmitter mux
//--------------------------------
void USBTxWireArbiter_L::txWireArb_mux()
{
  USBWireRdyOut.write(USBWireRdyIn.read());
}

void USBTxWireArbiter_L::txWireArb_arb()
{
  if (muxSIENotPTXB.read() == true)
  {
    USBWireWEn.write(SIETxWEn.read());
    TxBits.write(SIETxData.read());
    TxCtl.write(SIETxCtrl.read());
    TxFSRate.write(SIETxFSRate.read());
  }
  else
  {
    USBWireWEn.write(prcTxByteWEn.read());
    TxBits.write(prcTxByteData.read());
    TxCtl.write(prcTxByteCtrl.read());
    TxFSRate.write(prcTxByteFSRate.read());
  }
}

//--------------------------------------------------------------------
// Machine: txWireArb
//--------------------------------------------------------------------
//----------------------------------
// Next State Logic (combinatorial)
//----------------------------------
void USBTxWireArbiter_L::txWireArb_NextState()
{
  NextState_txWireArb.write(CurrState_txWireArb.read());
  // Set default values for outputs and signals
  next_prcTxByteGnt.write(prcTxByteGnt.read());
  next_muxSIENotPTXB.write(muxSIENotPTXB.read());
  next_SIETxGnt.write(SIETxGnt.read());

  switch(CurrState_txWireArb.read())
  {
    case START_TARB:
      NextState_txWireArb.write(TARB_WAIT_REQ);
      break;
    case TARB_WAIT_REQ:
      if (prcTxByteReq.read() == true)	
      {
        NextState_txWireArb.write(PTXB_ACT);
        next_prcTxByteGnt.write(true);
        next_muxSIENotPTXB.write(false);
      }
      else if (SIETxReq.read() == true)	
      {
        NextState_txWireArb.write(SIE_TX_ACT);
        next_SIETxGnt.write(true);
        next_muxSIENotPTXB.write(true);
      }
      break;
    case PTXB_ACT:
      if (prcTxByteReq.read() == false)	
      {
        NextState_txWireArb.write(TARB_WAIT_REQ);
        next_prcTxByteGnt.write(false);
      }
      break;
    case SIE_TX_ACT:
      if (SIETxReq.read() == false)	
      {
        NextState_txWireArb.write(TARB_WAIT_REQ);
        next_SIETxGnt.write(false);
      }
      break;
  }
}

//----------------------------------
// Current State Logic (sequential)
//----------------------------------
void USBTxWireArbiter_L::txWireArb_CurrentState()
{
  if (rst.read())	
    CurrState_txWireArb.write(START_TARB);
  else
    CurrState_txWireArb.write(NextState_txWireArb.read());
}

//----------------------------------
// Registered outputs logic
//----------------------------------
void USBTxWireArbiter_L::txWireArb_RegOutput()
{
  if (rst.read())	
  {
    muxSIENotPTXB.write(false);
    prcTxByteGnt.write(false);
    SIETxGnt.write(false);
  }
  else
  {
    muxSIENotPTXB.write(next_muxSIENotPTXB.read());
    prcTxByteGnt.write(next_prcTxByteGnt.read());
    SIETxGnt.write(next_SIETxGnt.read());
  }
}

