#include "systemc.h"

// constants
#define dwidth		32
#define awidth  	32
// added by nan
#define a_nan 		5
#define d_exp_nan	5

SC_MODULE(wb_master_model_H)
{
  bool	rst;
  sc_uint<dwidth-1> din;
  bool	ack;
  bool	err;
  bool	rty;
  
  sc_lv<awidth-1> adr;
  sc_lv<dwidth-1> dout;
  bool	cyc;
  bool	stb;
  bool	we;
  sc_lv<dwidth/8-1> sel;

  void initializeMem();
  void wb_write_task(unsigned, sc_lv<awidth-1>, sc_lv<dwidth-1>);
  sc_lv<dwidth-1> wb_read_task(unsigned, sc_lv<awidth-1>);
  void wb_cmp_task(unsigned, sc_lv<awidth-1>, sc_lv<dwidth-1>);

  // added by nan
  void call_task();
	
  sc_uint<dwidth-1> q;
  unsigned delay_nan;
  sc_lv<dwidth-1> lv_d;
  sc_lv<awidth-1> lv_a;

  SC_CTOR(wb_master_model_H)
  {
    SC_THREAD(initializeMem);
    SC_THREAD(call_task);
  }
};

