#include "systemc.h"

// constants
#define dwidth		32
#define awidth  	32
// added by nan
#define a_nan 		5
#define d_exp_nan	5

SC_MODULE(wb_master_model_L)
{
  sc_in<bool>	clk;
  sc_in<bool>	rst;
  sc_in<sc_uint<dwidth   -1> > din;
  sc_in<bool>	ack;
  sc_in<bool>	err;
  sc_in<bool>	rty;
  
  sc_out<sc_lv<awidth   -1> > adr;
  sc_out<sc_lv<dwidth   -1> > dout;
  sc_out<bool>	cyc;
  sc_out<bool>	stb;
  sc_out<bool>	we;
  sc_out<sc_lv<dwidth/8   -1> > sel;

  void initializeMem();
  void wb_write_task(unsigned, sc_lv<awidth -1>, sc_lv<dwidth -1>);
  sc_lv<dwidth -1> wb_read_task(unsigned, sc_lv<awidth -1>);
  void wb_cmp_task(unsigned, sc_lv<awidth -1>, sc_lv<dwidth -1>);
  // added by nan
  void call_task();
	
  sc_signal<sc_uint<dwidth   -1> > q;
  unsigned delay_nan;
  sc_lv<dwidth   -1> lv_d;
  sc_lv<awidth   -1> lv_a;

  SC_CTOR(wb_master_model_L)
  {
    SC_THREAD(initializeMem);

    SC_METHOD(call_task);
    sensitive << clk.pos();
  }
};

