`include "wb_master_model.v"

module top;

parameter dwidth_t = 32;
parameter awidth_t = 32;

reg   clk_t;
reg   rst_t;
reg[dwidth_t - 1:0]   din_t;
reg   ack_t;
reg   err_t;
reg   rty_t;

wire[dwidth_t - 1:0]  adr;
wire[dwidth_t - 1:0]  dout;
wire  cyc_t;
wire  stb_t;
wire  we_t;
wire [dwidth_t/8 -1:0]  sel_t;


// Clock generator
always
begin
  #5
  clk_t <= 1;
  #5
  clk_t <= 0;
end


initial begin
  $dumpfile ("wb_master_model.vcd");
  $dumpvars();
  rst_t <= 1;
  clk_t <= 0;
  
//   delay <= 0;

  din_t <= 100;
//   a <= 200;
//   d_exp <= 300;

  ack_t <= 0;
  err_t <= 0;
  rty_t <= 0;

  #10
  rst_t <= 0;
  
  #10
  ack_t <= 1;
  err_t <= 1;
  rty_t <= 1;

  #10
  ack_t <= 0;
  
  #10
  err_t <= 0;
  
  #10
  rty_t <= 0;
  ack_t <= 1;
  	
  #20 $finish;
end 

// Connect the DUT
wb_master_model U (
    clk_t, 
    rst_t, 
    adr, din_t, dout, cyc_t, stb_t, we_t, sel_t, ack_t, err_t, rty_t
);


always @ (posedge clk_t)
begin 
  $display ("%d %b %b %d %b %b %b \t %d %d %b %b %b %d ", $time, 
clk_t, rst_t, din_t, ack_t, err_t, rty_t, adr, dout, cyc_t, stb_t, we_t, sel_t);
end

endmodule
